#include <def21065L.h>

#define N 100

.section/dm seg_sdram;
.var destination[N];

.section/dm seg_dmda;
.var source[N];
.var dest[N];
.var int_count = 0;

.section/pm seg_rth;
//EMUI:
	nop;
	nop;
	nop;
	nop;
	
//RSTI:
	nop;
	jump start;
	nop;
	nop;

.section/pm seg_ep0;
	nop;
	jump ep0_isr;
	nop;
	nop;
		

.section/pm seg_pmco;
start:
	// Initialize the SDRAM controller
	call Init_SDRAM_Controller;
	
	i0 = source;
	m0 = 1;
	l0 = 0;
	
	r0 = 0xABAB0000;
	
	lcntr = N, do init_loop until lce;
	r0 = r0 + 1;
init_loop: dm(i0,m0) = r0;	
	
	// Enable external port interrupt
	
	bit set imask EP0I;
	bit set mode1 IRPTEN;
	nop;
	
	// Start the DMA to write to external SDRAM
	r0 = FLSH;
	dm(DMAC0) = r0;
	
	r0 = source;
	dm(II8) = r0;
	
	r0 = 1;
	dm(IM8) = r0;
	
	r0 = N;
	dm(C8) = r0;
	
	r0 = destination;
	dm(EI8) = r0;
	
	r0 = 1;
	dm(EM8) = r0;
	
	r0 = N;
	dm(EC8) = r0;
		
	r0 = TRAN | MASTER | DEN;
	dm(DMAC0) = r0;
	
	idle;

	// Wait for the FIFO to become empty before
	// starting the next DMA.		
poll_dmac:	
	r0 = dm(DMAC0);
	r1 = 0x00003000;
	r0 = r0 and r1;
	if ne jump poll_dmac;
	
	// Start the DMA to read from external SDRAM
	r0 = FLSH;
	dm(DMAC0) = r0;
	
	r0 = dest;
	dm(II8) = r0;
	
	r0 = 1;
	dm(IM8) = r0;
	
	r0 = N;
	dm(C8) = r0;
	
	r0 = destination;
	dm(EI8) = r0;
	
	r0 = 1;
	dm(EM8) = r0;
	
	r0 = N;
	dm(EC8) = r0;
		
	r0 = MASTER | DEN;
	dm(DMAC0) = r0;
	
	idle;
	
loophere:
	jump loophere;
	
	

Init_SDRAM_Controller:
	ustat1=dm(WAIT);
	bit clr ustat1 0x000f801f;	/*clear MS0 amd MS3 waitstate and mode*/
	dm(WAIT)=ustat1;
	ustat1=937;					/*refresh rate*/
	dm(SDRDIV)=ustat1;
	ustat1=dm(IOCTL);			/*mask in SDRAM settings*/
	bit set ustat1 SDPSS|SDBN2|SDBS3|SDTRP3|SDTRAS5|SDCL2|SDPGS256|DSDCK1;
	dm(IOCTL)=ustat1;
	
	rts;

// External port ISR	
ep0_isr:
	r0 = dm(int_count);
	r0 = r0 + 1;
	dm(int_count) = r0;
	
	rti;	
	